C----------------------------------------------------------------------
      subroutine coupless(nsrdm,nsrmax,dsr,tzffr,bzero,wgt,Vtautau)
c---------------------------------------------------------------------
C      Calculate the spin scalar polarization propagator in r space 
C      in RPA with the delta-type interaction
C     input
C      bzero(n1,n2,ist1,ist2,NDP1,NDP2) : 
c         free polarization propagator
C     result
C      tzffr(IRU,n1,n2,ist1,ist2,NDP1,NDP2): 
c         conj(polarization propagator)/cpi
c         IRU=1: Free,  =2: correlated
C----------------------------------------------------------------------
      implicit none
      integer nsrdm,nsrmax,n1,n2,md2,isw
      real*4  dsr,Vtautau,r2
      complex bzero(nsrdm*2*2,nsrdm*2*2,2,2,2,2)
      complex tzffr(2,nsrdm*2,nsrdm*2,2,2,2,2)
      complex szff(nsrdm,nsrdm)
      complex*16 a(nsrdm,nsrdm*2)
      real*4 wgt(*)
      real*8 cpi/3.141592654d0/
C
      do 108 n2=1,nsrmax
         r2=n2*dsr
         do 98 n1=1,nsrmax
            szff(n1,n2)=-bzero(n1,n2,1,1,1,1)*Vtautau/r2/r2*wgt(n2)
 98      continue
         szff(n2,n2)=szff(n2,n2)+(1.0,0.0)
 108  continue
      do 130 n2=1,nsrmax
         md2=nsrmax+n2
         do 120 n1=1,nsrmax
            a(n1,n2)=szff(n1,n2)
            a(n1,md2)=bzero(n1,n2,1,1,1,1)
 120     continue
 130  continue
C----------------------------------------------------------------------
        CALL CLNQGJ(a,nsrdm,nsrdm*2,nsrmax,nsrmax,isw)
C----------------------------------------------------------------------
C     RESPONSE FUNCTION for RPA
        do 170 n2=1,nsrmax
          md2=nsrmax+n2
          do 160 n1=1,nsrmax
            tzffr(2,n1,n2,1,1,1,1)=conjg(a(n1,md2)/CPI) 
  160     continue
  170   continue
c
      return
      end
