c======================================================================
      subroutine weffq(wefflq,wefftq,omega,NDPMIN,NDPMAX,nkmax,
     &                 fkdmsh,nkdm,obex)
c 
c   Calculate complex W_L^{\alpha,\beta} and W_T^{\alpha,\beta}
c   of Eqs.(3.36) and (3.37) in PPNP 
c   including h' terms and form factor of g' terms 
c======================================================================
      include 'opep.fh'
      include 'gprtrm.fh'
      include 'hprtrm.fh'
      include 'weff.fh'
      complex wdthp,wdthr,denpi,denrh,formp,formr,omegap,omegar
      dimension fkdmsh(*),fcoup(2)
c
      real*8 hc/197.326968d0/
      real*8 cpi/3.141592654d0/
c
      fcoup(1) = 1.0
      fcoup(2) = fratio
      pm2   = epion*epion
      rm2   = erhoo*erhoo
      fac   = (hc**3)*4.0*CPI*facbs/pm2
      wdthp = cmplx(0.0,wdthpi)
      wdthr = cmplx(0.0,wdthrh)
      omegap= omega+wdthp
      omegar= omega+wdthr
c
c     do loop for (N,N), (N,D), (D,D)
c
      Do 10 NDP1=NDPMIN,NDPMAX
      Do 20 NDP2=NDPMIN,NDPMAX
c
        fcpl = fcoup(NDP1)*fcoup(NDP2)*fac
        ctp1 = ctpi(NDP1)
        ctp2 = ctpi(NDP2)
        ctr1 = ctrh(NDP1)
        ctr2 = ctrh(NDP2)
        npi1 = nctpi(NDP1)
        npi2 = nctpi(NDP2)
        nrh1 = nctrh(NDP1)
        nrh2 = nctrh(NDP2)
C
      do 30 k=1,nkmax
         sk    = fkdmsh(k)
         sk2   = hc*hc*sk*sk
         t     = omega*omega-sk2
         denpi = omegap*omegap-sk2-pm2
         denrh = omegar*omegar-sk2-rm2
         formg = gpr(NDP1,NDP2)*gama(t,0.0,ctgpr,nctgpr)
         formh = hpr(NDP1,NDP2)*gama(t,0.0,cthpr,ncthpr)*(sk2/pm2)
         cutp  = gama(t,epion,ctp1,npi1)*gama(t,epion,ctp2,npi2)
         cutr  = gama(t,erhoo,ctr1,nrh1)*gama(t,erhoo,ctr2,nrh2)
         formp = obex*(sk2/denpi)*cutp
         formr = obex*(sk2/denrh)*cutr*crhoo
         wefflq(k,NDP1,NDP2) = (formp+formg+2.0*formh)*fcpl
         wefftq(k,NDP1,NDP2) = (formr+formg-formh)*fcpl
   30 continue
   20 continue
   10 continue
c
      return
      end
c----------------------------------------------------------------------
      function gama(t,m,lamd,n)
c     vertex form factor
c      gama = [(lamd^2-m^2)/(lamd^2-t)]^n
c----------------------------------------------------------------------
      implicit none
      real gama,m,lamd,t,lamdsq
      integer n
c
      if(n.eq.0) then
         gama=1.0
         else
            lamdsq=lamd*lamd
            gama = ((lamdsq-m*m)/(lamdsq-t))**n
      end if
C
      return
      end
c---------------------------------------------------------------------
